import type { SerializedError, SerializedRegex, SerializedDate } from "./serializers";
type Deserializer<V, S> = (serializedValue: S, key: string) => V;
type PrimitiveDeserializer<V, S = V> = (serializedValue: S, key: string) => V;
type Deserializers = {
    [key: string]: Deserializer<unknown, any>;
    function: Deserializer<unknown, unknown>;
    error: Deserializer<Error, SerializedError>;
    promise: Deserializer<unknown, unknown>;
    regex: Deserializer<RegExp, SerializedRegex>;
    date: Deserializer<Date, SerializedDate>;
    array: PrimitiveDeserializer<readonly unknown[]>;
    object: PrimitiveDeserializer<Record<string, unknown>>;
    string: PrimitiveDeserializer<string>;
    number: PrimitiveDeserializer<number>;
    boolean: PrimitiveDeserializer<boolean>;
    null: PrimitiveDeserializer<undefined>;
    undefined: PrimitiveDeserializer<void>;
};
export declare function deserialize<T>(str: string, deserializers?: Partial<Deserializers>): T;
export {};
